diff -r fb51f5b4aa4c trytond/test/__init__.py
--- a/trytond/test/__init__.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/test/__init__.py	Mon Sep 24 20:36:36 2012 +0200
@@ -1,6 +1,6 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-
+from ..pool import Pool
 from .test import *
 from .model import *
 from .mptt import *
@@ -10,3 +10,113 @@
 from .access import *
 from .wizard import *
 from .workflow import *
+
+
+def register():
+    Pool.register(
+        Boolean,
+        BooleanDefault,
+        Integer,
+        IntegerDefault,
+        IntegerRequired,
+        Float,
+        FloatDefault,
+        FloatRequired,
+        FloatDigits,
+        Numeric,
+        NumericDefault,
+        NumericRequired,
+        NumericDigits,
+        Char,
+        CharDefault,
+        CharRequired,
+        CharSize,
+        CharTranslate,
+        Text,
+        TextDefault,
+        TextRequired,
+        TextSize,
+        TextTranslate,
+        Sha,
+        ShaDefault,
+        ShaRequired,
+        Date,
+        DateDefault,
+        DateRequired,
+        DateTime,
+        DateTimeDefault,
+        DateTimeRequired,
+        DateTimeFormat,
+        Time,
+        TimeDefault,
+        TimeRequired,
+        TimeFormat,
+        One2One,
+        One2OneTarget,
+        One2OneRelation,
+        One2OneRequired,
+        One2OneRequiredRelation,
+        One2Many,
+        One2ManyTarget,
+        One2ManyRequired,
+        One2ManyRequiredTarget,
+        One2ManyReference,
+        One2ManyReferenceTarget,
+        One2ManySize,
+        One2ManySizeTarget,
+        One2ManySizePYSON,
+        One2ManySizePYSONTarget,
+        Many2Many,
+        Many2ManyTarget,
+        Many2ManyRelation,
+        Many2ManyRequired,
+        Many2ManyRequiredTarget,
+        Many2ManyRequiredRelation,
+        Many2ManyReference,
+        Many2ManyReferenceTarget,
+        Many2ManyReferenceRelation,
+        Many2ManySize,
+        Many2ManySizeTarget,
+        Many2ManySizeRelation,
+        Reference,
+        ReferenceTarget,
+        ReferenceRequired,
+        Property,
+        Singleton,
+        URLObject,
+        ModelInherits,
+        ModelInheritsSubModel,
+        ModelInheritsSubSubModel,
+        ModelInheritsSubSubSubModel,
+        ModelInheritsOverriddenFieldModel,
+        MPTT,
+        ImportDataBoolean,
+        ImportDataInteger,
+        ImportDataFloat,
+        ImportDataNumeric,
+        ImportDataChar,
+        ImportDataText,
+        ImportDataSha,
+        ImportDataDate,
+        ImportDataDateTime,
+        ImportDataSelection,
+        ImportDataMany2OneTarget,
+        ImportDataMany2One,
+        ImportDataMany2ManyTarget,
+        ImportDataMany2Many,
+        ImportDataMany2ManyRelation,
+        ImportDataOne2Many,
+        ImportDataOne2ManyTarget,
+        ImportDataReferenceSelection,
+        ImportDataReference,
+        ExportDataTarget,
+        ExportData,
+        ExportDataRelation,
+        Triggered,
+        TestAccess,
+        TestWizardStart,
+        WorkflowedModel,
+        module='test', type_='model')
+    Pool.register(
+        TestWizard,
+        module='test', type_='wizard')
diff -r fb51f5b4aa4c trytond/test/access.py
--- a/trytond/test/access.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/test/access.py	Mon Sep 24 20:36:36 2012 +0200
@@ -2,13 +2,13 @@
 #this repository contains the full copyright notices and license terms.
 from trytond.model import ModelSQL, fields
 
+__all__ = [
+    'TestAccess',
+    ]
+
 
 class TestAccess(ModelSQL):
     'Test Access'
-    _name = 'test.access'
-    _description = __doc__
-
+    __name__ = 'test.access'
     field1 = fields.Char('Field 1')
     field2 = fields.Char('Field 2')
-
-TestAccess()
diff -r fb51f5b4aa4c trytond/test/export_data.py
--- a/trytond/test/export_data.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/test/export_data.py	Mon Sep 24 20:36:36 2012 +0200
@@ -3,20 +3,20 @@
 "Test for export_data"
 from trytond.model import ModelSQL, fields
 
+__all__ = [
+    'ExportDataTarget', 'ExportData', 'ExportDataRelation',
+    ]
+
 
 class ExportDataTarget(ModelSQL):
     "Export Data Target"
-    _name = 'test.export_data.target'
-    _description = __doc__
+    __name__ = 'test.export_data.target'
     name = fields.Char('Name')
 
-ExportDataTarget()
-
 
 class ExportData(ModelSQL):
     "Export Data"
-    _name = 'test.export_data'
-    _description = __doc__
+    __name__ = 'test.export_data'
     boolean = fields.Boolean('Boolean')
     integer = fields.Integer('Integer')
     float = fields.Float('Float')
@@ -40,20 +40,15 @@
         ('test.export_data.target', 'Target'),
         ])
 
-ExportData()
-
 
 class ExportDataTarget(ExportDataTarget):
+    'Export Date Target'
+    __name__ = 'test.export_data.target'
     one2many = fields.Many2One('test.export_data', 'Export Data')
 
-ExportDataTarget()
-
 
 class ExportDataRelation(ModelSQL):
     "Export Data Many2Many"
-    _name = 'test.export_data.relation'
-    _description = __doc__
+    __name__ = 'test.export_data.relation'
     many2many = fields.Many2One('test.export_data', 'Export Data')
     target = fields.Many2One('test.export_data.target', 'Target')
-
-ExportDataRelation()
diff -r fb51f5b4aa4c trytond/test/import_data.py
--- a/trytond/test/import_data.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/test/import_data.py	Mon Sep 24 20:36:36 2012 +0200
@@ -3,182 +3,138 @@
 "Test for import_data"
 from trytond.model import ModelSQL, fields
 
+__all__ = [
+    'ImportDataBoolean', 'ImportDataInteger', 'ImportDataFloat',
+    'ImportDataNumeric', 'ImportDataChar', 'ImportDataText', 'ImportDataSha',
+    'ImportDataDate', 'ImportDataDateTime', 'ImportDataSelection',
+    'ImportDataMany2OneTarget', 'ImportDataMany2One',
+    'ImportDataMany2ManyTarget', 'ImportDataMany2Many',
+    'ImportDataMany2ManyRelation', 'ImportDataOne2Many',
+    'ImportDataOne2ManyTarget', 'ImportDataReferenceSelection',
+    'ImportDataReference',
+    ]
+
 
 class ImportDataBoolean(ModelSQL):
     "Import Data Boolean"
-    _name = 'test.import_data.boolean'
-    _description = __doc__
+    __name__ = 'test.import_data.boolean'
     boolean = fields.Boolean('Boolean')
 
-ImportDataBoolean()
-
 
 class ImportDataInteger(ModelSQL):
     "Import Data Integer"
-    _name = 'test.import_data.integer'
-    _description = __doc__
+    __name__ = 'test.import_data.integer'
     integer = fields.Integer('Integer')
 
-ImportDataInteger()
-
 
 class ImportDataFloat(ModelSQL):
     "Import Data Float"
-    _name = 'test.import_data.float'
-    _description = __doc__
+    __name__ = 'test.import_data.float'
     float = fields.Float('Float')
 
-ImportDataFloat()
-
 
 class ImportDataNumeric(ModelSQL):
     "Import Data Numeric"
-    _name = 'test.import_data.numeric'
-    _description = __doc__
+    __name__ = 'test.import_data.numeric'
     numeric = fields.Numeric('Numeric')
 
-ImportDataNumeric()
-
 
 class ImportDataChar(ModelSQL):
     "Import Data Char"
-    _name = 'test.import_data.char'
-    _description = __doc__
+    __name__ = 'test.import_data.char'
     char = fields.Char('Char')
 
-ImportDataChar()
-
 
 class ImportDataText(ModelSQL):
     "Import Data Text"
-    _name = 'test.import_data.text'
-    _description = __doc__
+    __name__ = 'test.import_data.text'
     text = fields.Text('Text')
 
-ImportDataText()
-
 
 class ImportDataSha(ModelSQL):
     "Import Data Sha"
-    _name = 'test.import_data.sha'
-    _description = __doc__
+    __name__ = 'test.import_data.sha'
     sha = fields.Sha('Sha')
 
-ImportDataSha()
-
 
 class ImportDataDate(ModelSQL):
     "Import Data Date"
-    _name = 'test.import_data.date'
-    _description = __doc__
+    __name__ = 'test.import_data.date'
     date = fields.Date('Date')
 
-ImportDataDate()
-
 
 class ImportDataDateTime(ModelSQL):
     "Import Data DateTime"
-    _name = 'test.import_data.datetime'
-    _description = __doc__
+    __name__ = 'test.import_data.datetime'
     datetime = fields.DateTime('DateTime')
 
-ImportDataDateTime()
-
 
 class ImportDataSelection(ModelSQL):
     "Import Data Selection"
-    _name = 'test.import_data.selection'
-    _description = __doc__
+    __name__ = 'test.import_data.selection'
     selection = fields.Selection([
         ('select1', 'Select 1'),
         ('select2', 'Select 2'),
         ], 'Selection')
 
-ImportDataSelection()
-
 
 class ImportDataMany2OneTarget(ModelSQL):
     "Import Data Many2One Target"
-    _name = 'test.import_data.many2one.target'
-    _description = __doc__
+    __name__ = 'test.import_data.many2one.target'
     name = fields.Char('Name')
 
-ImportDataMany2OneTarget()
-
 
 class ImportDataMany2One(ModelSQL):
     "Import Data Many2One"
-    _name = 'test.import_data.many2one'
-    _description = __doc__
+    __name__ = 'test.import_data.many2one'
     many2one = fields.Many2One('test.import_data.many2one.target',
             'Many2One')
 
-ImportDataMany2One()
-
 
 class ImportDataMany2ManyTarget(ModelSQL):
     "Import Data Many2Many Target"
-    _name = 'test.import_data.many2many.target'
-    _description = __doc__
+    __name__ = 'test.import_data.many2many.target'
     name = fields.Char('Name')
 
-ImportDataMany2ManyTarget()
-
 
 class ImportDataMany2Many(ModelSQL):
     "Import Data Many2Many"
-    _name = 'test.import_data.many2many'
-    _description = __doc__
+    __name__ = 'test.import_data.many2many'
     many2many = fields.Many2Many('test.import_data.many2many.relation',
             'many2many', 'target', 'Many2Many')
 
-ImportDataMany2Many()
-
 
 class ImportDataMany2ManyRelation(ModelSQL):
     "Import Data Many2Many Relation"
-    _name = 'test.import_data.many2many.relation'
+    __name__ = 'test.import_data.many2many.relation'
     many2many = fields.Many2One('test.import_data.many2many', 'Many2One')
     target = fields.Many2One('test.import_data.many2many.target', 'Target')
 
-ImportDataMany2ManyRelation()
-
 
 class ImportDataOne2Many(ModelSQL):
     "Import Data One2Many"
-    _name = 'test.import_data.one2many'
-    _description = __doc__
+    __name__ = 'test.import_data.one2many'
     name = fields.Char('Name')
     one2many = fields.One2Many('test.import_data.one2many.target', 'one2many',
             'One2Many')
 
-ImportDataOne2Many()
-
 
 class ImportDataOne2ManyTarget(ModelSQL):
     "Import Data One2Many Target"
-    _name = 'test.import_data.one2many.target'
-    _description = __doc__
+    __name__ = 'test.import_data.one2many.target'
     name = fields.Char('Name')
     one2many = fields.Many2One('test.import_data.one2many', 'One2Many')
 
-ImportDataOne2ManyTarget()
-
 
 class ImportDataReferenceSelection(ModelSQL):
     "Import Data Reference Selection"
-    _name = 'test.import_data.reference.selection'
-    _description = __doc__
+    __name__ = 'test.import_data.reference.selection'
     name = fields.Char('Name')
 
-ImportDataReferenceSelection()
-
 
 class ImportDataReference(ModelSQL):
     "Import Data Reference"
-    _name = 'test.import_data.reference'
+    __name__ = 'test.import_data.reference'
     reference = fields.Reference('Reference', [
         ('test.import_data.reference.selection', 'Test'),
         ])
-
-ImportDataReference()
diff -r fb51f5b4aa4c trytond/test/model.py
--- a/trytond/test/model.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/test/model.py	Mon Sep 24 20:36:36 2012 +0200
@@ -2,76 +2,71 @@
 #this repository contains the full copyright notices and license terms.
 from trytond.model import ModelSingleton, ModelSQL, fields
 
+__all__ = [
+    'Singleton', 'URLObject', 'ModelInherits', 'ModelInheritsSubModel',
+    'ModelInheritsSubSubModel', 'ModelInheritsSubSubSubModel',
+    'ModelInheritsOverriddenFieldModel',
+    ]
+
 
 class Singleton(ModelSingleton, ModelSQL):
     'Singleton'
-    _name = 'test.singleton'
-    _description = __doc__
+    __name__ = 'test.singleton'
+    name = fields.Char('Name')
+
+    @staticmethod
+    def default_name():
+        return 'test'
+
+
+class URLObject(ModelSQL):
+    'URLObject'
+    __name__ = 'test.urlobject'
+    name = fields.Char('Name')
+
+
+class ModelInherits(ModelSQL):
+    'Model Inherits'
+    __name__ = 'test.model_inherits'
 
     name = fields.Char('Name')
 
-    def default_name(self):
-        return 'test'
-
-Singleton()
-
-
-class URLObject(ModelSQL):
-    _name = 'test.urlobject'
-
-    name = fields.Char('Name')
-
-
-URLObject()
-
-
-class ModelInherits(ModelSQL):
-    _name = 'test.model_inherits'
-
-    name = fields.Char('Name')
-
-ModelInherits()
-
 
 class ModelInheritsSubModel(ModelSQL):
-    _name = 'test.submodel'
+    'Model Inherits Sub-Model'
+    __name__ = 'test.submodel'
     _inherits = {'test.model_inherits': 'parent_model'}
 
     subfield = fields.Char('SubField')
     parent_model = fields.Many2One('test.model_inherits', 'Parent model',
         required=True)
 
-ModelInheritsSubModel()
-
 
 class ModelInheritsSubSubModel(ModelSQL):
-    _name = 'test.subsubmodel'
+    'Model Inherits Sub-Sub-Model'
+    __name__ = 'test.subsubmodel'
     _inherits = {'test.submodel': 'parent_model'}
 
     subsubfield = fields.Char('SubField')
     parent_model = fields.Many2One('test.submodel', 'Parent model',
         required=True)
 
-ModelInheritsSubSubModel()
-
 
 class ModelInheritsSubSubSubModel(ModelSQL):
-    _name = 'test.subsubsubmodel'
+    'Model Inherits Sub-Sub-Sub-Model'
+    __name__ = 'test.subsubsubmodel'
     _inherits = {'test.subsubmodel': 'parent_model'}
 
     subsubsubfield = fields.Char('SubField')
     parent_model = fields.Many2One('test.subsubmodel', 'Parent model',
         required=True)
 
-ModelInheritsSubSubSubModel()
-
 
 class ModelInheritsOverriddenFieldModel(ModelSQL):
-    _name = 'test.overriddeninheritedfieldmodel'
+    'Model Inherits Overridden Field Model'
+    __name__ = 'test.overriddeninheritedfieldmodel'
     _inherits = {'test.subsubmodel': 'parent_model'}
 
     subfield = fields.Integer('Overridden field')
     parent_model = fields.Many2One('test.subsubmodel', 'Parent model',
         required=True)
-
-ModelInheritsOverriddenFieldModel()
diff -r fb51f5b4aa4c trytond/test/mptt.py
--- a/trytond/test/mptt.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/test/mptt.py	Mon Sep 24 20:36:36 2012 +0200
@@ -3,11 +3,14 @@
 "Test for Tree"
 from trytond.model import ModelView, ModelSQL, fields
 
+__all__ = [
+    'MPTT',
+    ]
+
 
 class MPTT(ModelSQL, ModelView):
     'Modified Preorder Tree Traversal'
-    _name = 'test.mptt'
-    _description = __doc__
+    __name__ = 'test.mptt'
     name = fields.Char('Name', required=True)
     sequence = fields.Integer('Sequence',
         order_field='(%(table)s.sequence IS NULL) %(order)s, '
@@ -19,23 +22,25 @@
     childs = fields.One2Many('test.mptt', 'parent', 'Children')
     active = fields.Boolean('Active')
 
-    def __init__(self):
-        super(MPTT, self).__init__()
-        self._order.insert(0, ('sequence', 'ASC'))
-        self._constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(MPTT, cls).__setup__()
+        cls._order.insert(0, ('sequence', 'ASC'))
+        cls._constraints += [
             ('check_recursion', 'recursive_mptt'),
         ]
-        self._error_messages.update({
+        cls._error_messages.update({
             'recursive_mptt': 'You can not create recursive Tree!',
         })
 
-    def default_active(self):
+    @staticmethod
+    def default_active():
         return True
 
-    def default_left(self):
+    @staticmethod
+    def default_left():
         return 0
 
-    def default_right(self):
+    @staticmethod
+    def default_right():
         return 0
-
-MPTT()
